<?php
if ( ! defined('BASEPATH')) exit('No direct script access allowed');
class Billing_member_subscription extends REF_Controller {
    public function __construct() {
        parent::__construct();
        $this->load->library('upload');
        $this->load->model('billing/member_subscription_model', '', TRUE);
        $this->load->model('login_details_model', '', TRUE);
        $this->uri_key_index = 0;
    }
    
    public function index($id = 11) {
        $data = array();
        $data['results'] = $this->member_subscription_model->list_all();
        if (!empty($this->session->flashdata('success'))) 
            $data['success'] = $this->session->flashdata('success');
        else 
            $data['error'] = $this->session->flashdata('error');
        
        $actions = $this->actions();
        $service_menu = get_billing_controller($actions['controller']);
        $data['add_btn']    = 'Create New ' . $service_menu->service_name;
        $data['view_link']  = $actions['view'] . '/';
        $data['add_link']   = $actions['add'] . '/' . $id ;
        $data['edit_link']  = $actions['edit'] . '/';
        $data['delete_link']= $actions['delete'] . '/';
        $data['print'] = base_url() . 'billing_member_subscription/print_list/';
       
        $data['menu_id'] = $id;
        $data['title'] = $service_menu->service_name;
        $data['service_menu_id'] = array('service_menu_id' => $service_menu->id, 'menu_type' => '4');
        $this->render($data, 'billing/member_subscription/list');
    }
    
    public function add($type_id= '') {
        $data = array();
        $actions = $this->actions();
        $service_menu = get_billing_controller($actions['controller']);
        
        $data['payments'] = $this->member_subscription_model->payment_mode_lists();
        $data['service_type'] = $this->member_subscription_model->get_service_type($type_id);
        $data['service_type_id'] = $type_id; 
        
        $data['form_action'] = $actions['insert'];
        $data['title'] = $service_menu->service_name;
        $this->render($data, 'billing/member_subscription/add');
    }
    
    private function get_member_subscript_url_key($name, $id = '') {
        $url_key = get_url_key($name);
        if ($this->member_subscription_model->member_subscript_url_key_exists($url_key, $id)) {
            $this->uri_key_index ++;
            return $this->get_member_subscript_url_key($name . '_' . $this->uri_key_index, $id);
        }
        
        return $url_key;
    }
    
    public function insert() {
        $actions = $this->actions();
        $serviceMenu = get_billing_controller($actions['controller']);
        
        $services = $this->member_subscription_model->service_type_exists($this->input->post('service_type'));
        $gst_details = $this->login_details_model->get_amount_by_service_id($this->input->post('service_type'));
        
        if($gst_details->gst == 1) {
            $gst = get_general_setting()->gst; 
            $gst_amount = ($gst / 100) * ($this->input->post('amount'));
        } else {
            $gst = '0.00';
            $gst_amount = '0.00';
        }
        
        $insert = array(
            'type_id' => $this->input->post('service_type_id'),
            'service_id' => $this->input->post('service_type'),
            'member_name'=> $this->input->post('member_name'),
            'tamil_name' => htmlspecialchars( $this->input->post('tamil_member_name') ),
            'entry_fee' => $this->input->post('entry_fee'),
            'entry_fee_amount' => $this->input->post('fee_amount'),
            'member_no'=> $this->input->post('member_no'),
            'contact_no' => $this->input->post('contact_no'),
            'dob' => date('Y-m-d',strtotime($this->input->post('dob'))),
            'sex' => $this->input->post('sex'),
            'maritial_status'=> $this->input->post('maritial_status'),
            'address' => $this->input->post('address'),
            'email' => $this->input->post('email'),
            'postal_code' => $this->input->post('postal_code'),
            'date_of_join' => date('Y-m-d',strtotime($this->input->post('date_join'))),
            'amount' => $this->input->post('amount'),
            'gst' => $gst,
            'gst_value' => $gst_amount,
            'desc' => $this->input->post('desc'),
            'payment_mode' => $this->input->post('payment_mode'),
            'url_key' => $this->get_member_subscript_url_key($this->input->post('member_name')),
            'created_by' => $this->user_data['user_id'],
            'created_on' => date('Y-m-d H:i:s')
        );
        
        $insert_id = $this->member_subscription_model->insert($insert);
        
        if ($insert_id > 0) {
            $this->session->set_flashdata('success', 'Billing for ' . $serviceMenu->service_name . ' is added successfully');
            if($services->num_rows() > 0) {
                $last_receipt_no = $services->row()->receipt_no;
                $last_no = (int)$last_receipt_no;
                $receipt_no = (($last_no + 1)  > 9999) ? ($last_no + 1)  : sprintf('0%03d', ($last_no + 1) );
            } else
                $receipt_no = '0001';
            
            $update = array(
                'receipt_no' => $receipt_no
            );
            $this->member_subscription_model->update($update, $insert_id);
            
            $pay_type = $this->input->post('pay_type');
            foreach( $pay_type as $key => $value ) {
                if($value != '') {
                    $this->db->select('slug');
                    $q = $this->db->get_where( TBL_PAY_TYPE, array('id' => $key) );
                    $prow = $q->row_array();
                       
                    $pay_details = array();
                    if( $prow['slug'] == 'cheque' && !empty($value) ) :
                        // Cheque
                        $e = explode('-', $this->input->post('chq_date'));
                        $pay_details = array(
                            'name'   => $this->input->post('chq_bnk_name'),
                            'no'   => $this->input->post('chq_no'),
                            'date'   => $e[2].'-'.$e[1].'-'.$e[0],
                        );
                    endif;
                       
                    $pay_details = json_encode( $pay_details );
                    
                    $insert = array(
                        'pay_ref_type'  => 11,
                        'pay_ref_id'    => $insert_id,
                        'pay_type_id'   => $key,
                        'pay_amount'    => trim($value),
                        'pay_details'   => $pay_details,
                        'status'        => 1,
                        'created_by'    => $this->user_data['user_id'],
                        'created_on'    => date('Y-m-d H:i:s')
                    );
                    $this->member_subscription_model->insert_payment($insert);
                }
            }
            
            /*** To Print Receipt - Start ***/
            $service_menu = $this->login_details_model->get_service_menu_by_id($this->input->post('service_type_id'));
            $prefix = get_general_setting()->prefix;
            
            $args = array(
                'type'      => '1', // Default = 1 // Normal (Double print), '2' => Archanai,   '3' = Hall Booking | Wedding Hall
                'rec_no'    => (($prefix == 1) ? $gst_details->prefix : '') . $receipt_no,
                'title'     => $service_menu->service_name . ' - ' . $gst_details->name,
                'amount'    => array($this->input->post('amount')),
                'gst'       => $gst_details->gst,
                'created_on' => date('Y-m-d H:i:s'),
                
                'data'      => array(
                    // Type = 1 && 3 
                    'name'      => array($this->input->post('member_name') .','.  $this->input->post('tamil_member_name')),
                    'contact_no'=> $this->input->post('contact_no'),
                    'email'     => $this->input->post('email'),
                    'address'   => $this->input->post('address') . ((!empty($this->input->post('postal_code'))) ? ' / Postal Code: ' . $this->input->post('postal_code') : ''),
                    'desc'      => $this->input->post('desc'),
                ),
                
            );
            
            print_rec($args);            
            /*** End ***/
        }
        else
            $this->session->set_flashdata('error', 'Billing for ' . $serviceMenu->service_name . ' is not added!');   
       
        redirect('billing_member_subscription', 'refresh');
    }
    
    public function edit($id = '') {
        if (empty($id)) {
            show_400_error();
        }
        
        $data = array();
        $actions = $this->actions();
        $service_menu = get_billing_controller($actions['controller']);
        
        $data['payments'] = $this->member_subscription_model->payment_mode_lists();
        $data['members'] = $this->member_subscription_model->get_by_id($id);
        $data['paid_amount'] = $this->member_subscription_model->total_paid_amount($data['members']->type_id,$data['members']->id);
        $data['service_type'] = $this->member_subscription_model->get_service_type($data['members']->type_id);
        
        $actions = $this->actions();
        $data['title'] = $service_menu->service_name;
        $data['form_action'] = $actions['update'] . '/' . $id;
        $this->render($data, 'billing/member_subscription/edit');
    }
    
    public function update($id = '') {
        if (empty($id)) {
            show_400_error();
        }
        
        $actions = $this->actions();
        $service_menu = get_billing_controller($actions['controller']);
        
        $members = $this->member_subscription_model->get_by_id($id);
        $gst_details = $this->login_details_model->get_amount_by_service_id($this->input->post('service_type'));
        
        if($gst_details->gst == 1) {
            $gst = get_general_setting()->gst; 
            $gst_amount = ($gst / 100) * ($this->input->post('amount'));
        } else {
            $gst = '0.00';
            $gst_amount = '0.00';
        }
        
        $update = array(
            'type_id' => $this->input->post('service_type_id'),
            'service_id' => $this->input->post('service_type'),
            'member_name'=> $this->input->post('member_name'),
            'tamil_name' => htmlspecialchars( $this->input->post('tamil_member_name') ),
            'entry_fee' => $this->input->post('entry_fee'),
            'entry_fee_amount' => $this->input->post('fee_amount'),
            'member_no'=> $this->input->post('member_no'),
            'contact_no' => $this->input->post('contact_no'),
            'dob' => date('Y-m-d',strtotime($this->input->post('dob'))),
            'sex' => $this->input->post('sex'),
            'maritial_status'=> $this->input->post('maritial_status'),
            'address' => $this->input->post('address'),
            'email' => $this->input->post('email'),
            'postal_code' => $this->input->post('postal_code'),
            'date_of_join' => date('Y-m-d',strtotime($this->input->post('date_join'))),
            'amount' => $this->input->post('amount'),
            'gst' => $gst,
            'gst_value' => $gst_amount,
            'desc' => $this->input->post('desc'),
            'payment_mode' => $this->input->post('payment_mode'),
            'url_key' => $this->get_member_subscript_url_key($this->input->post('member_name')),
            'updated_by' => $this->user_data['user_id'],
            'updated_on' => date('Y-m-d H:i:s')
        );
        
        if ($this->member_subscription_model->update($update, $id) > 0) {
            $this->session->set_flashdata('success', 'Billing for ' . $service_menu->service_name . ' is updated successfully');
            
            $paid_hidden_id = $this->input->post('paid_hidden_id');
            if(!empty($paid_hidden_id)) :
                $paidtype = $this->member_subscription_model->delete_payment_by_paid_id($paid_hidden_id);
            endif;
            
            $pay_type = $this->input->post('pay_type');
            foreach( $pay_type as $key => $value ) {
                if($value != '') {
                    $this->db->select('slug');
                    $q = $this->db->get_where( TBL_PAY_TYPE, array('id' => $key) );
                    $prow = $q->row_array();
                       
                    $pay_details = array();
                    if( $prow['slug'] == 'cheque' && !empty($value) ) :
                        // Cheque
                        $e = explode('-', $this->input->post('chq_date'));
                        $pay_details = array(
                            'name'   => $this->input->post('chq_bnk_name'),
                            'no'   => $this->input->post('chq_no'),
                            'date'   => $e[2].'-'.$e[1].'-'.$e[0],
                        );
                    endif;
                       
                    $pay_details = json_encode( $pay_details );
                    
                    $insert = array(
                        'pay_ref_type'  => 11,
                        'pay_ref_id'    => $id,
                        'pay_type_id'   => $key,
                        'pay_amount'    => trim($value),
                        'pay_details'   => $pay_details,
                        'status'        => 1,
                        'created_by'    => $this->user_data['user_id'],
                        'created_on'    => $members->created_on
                    );
                    $this->member_subscription_model->insert_payment($insert);
                }
            }
        }
        else
            $this->session->set_flashdata('error', 'Billing for ' . $service_menu->service_name . ' is not updated!');    
        
        redirect('billing_member_subscription','refresh');
    }
    
    public function view($id = '') {
        if (empty($id)) {
            show_400_error();
        }
        
        $data = array();
        $actions = $this->actions();
        $service_menu = get_billing_controller($actions['controller']);
        
        $data['members'] = $this->member_subscription_model->get_by_id($id);
        $data['payments'] = $this->member_subscription_model->get_paid_type_by_id($data['members']->type_id,$id);
        $data['paid_amount'] = $this->member_subscription_model->total_paid_amount($data['members']->type_id,$data['members']->id);
        $data['title'] = $service_menu->service_name;
        $this->render($data, 'billing/member_subscription/view');
    }
    
    public function delete($id = '', $menu_id = '') {
        if (empty($id)) {
            show_400_error();
        }
        
        $actions = $this->actions();
        $service_menu = get_billing_controller($actions['controller']);
        
        $update = array ( 
            'amount' => 0,
            'del_reason' => $this->input->post('hidden_del_reason'),
            'status' => 2,
            'updated_by' => $this->user_data['user_id'],
            'updated_on' => date('Y-m-d H:i:s')
        );
       
        if ($this->member_subscription_model->update($update,$id) > 0) {
            $this->session->set_flashdata('success', 'Billing for ' . $service_menu->service_name . ' is deleted successfully');
            $members = $this->member_subscription_model->get_by_id($id);
            
            $update = array ( 
                'pay_amount' => 0,
                'updated_by' => $this->user_data['user_id'],
                'updated_on' => date('Y-m-d H:i:s')
            );
            
            $this->member_subscription_model->update_paid_type($update,$members->type_id,$id);
        }
        else 
            $this->session->set_flashdata('error', 'Billing for ' . $service_menu->service_name . ' is not deleted!');
        
        redirect( 'billing_member_subscription/index/' . $menu_id, 'refresh');
    }
    
    public function get_amount_by_service_id() {
        $data =  $this->member_subscription_model->get_amount_by_service_id($_POST['service_type']);
        echo json_encode($data);
        exit(0);
    }
    
    public  function print_list($id,$menu_id) {
        $members = $this->member_subscription_model->get_by_id($id);
        
        /*** To Print Receipt - Start ***/
        $service_menu = $this->login_details_model->get_service_menu_by_id($members->type_id);
        $gst_details = $this->login_details_model->get_amount_by_service_id($members->service_id);
        $prefix = get_general_setting()->prefix;
        
        $args = array(
            'type'      => '1', // Default = 1 // Normal (Double print), '2' => Archanai,   '3' = Hall Booking | Wedding Hall
            'rec_no'    => (($prefix == 1) ? $gst_details->prefix : '') . $members->receipt_no,
            'title'     => $service_menu->service_name . ' - ' . $gst_details->name,
            'amount'    => array($members->amount),
            'gst'       => $gst_details->gst,
            'status'    => $members->status,
            'created_on' => $members->created_on,
            
            'data'      => array(
                // Type = 1 && 3 
                'name'      => array($members->member_name .','.  $members->tamil_name),
                'contact_no'=> $members->contact_no,
                'email'     => $members->email,
                'address'   => $members->address . ((!empty($members->postal_code)) ? ' / <b>Postal Code:</b> ' . $members->postal_code : ''),
                'desc'      => $members->desc,
            ),
            
        );
        
        if(print_rec($args))
            $this->session->set_flashdata('success', 'Receipt has been printed successfully');
        
        else 
            $this->session->set_flashdata('error', 'Receipt has not been printed!');
            
        /*** End ***/
        
        redirect( 'billing_member_subscription/index/' . $menu_id, 'refresh');
    }
    
    public function check_mem_no_exists() {
        $data = $this->member_subscription_model->check_mem_no_exists($_POST['mem_no'],$_POST['mem_id']);
        echo json_encode($data);
    }
}
?>